Index: trunk/BNC/qwt/qwt_legend.cpp
===================================================================
--- trunk/BNC/qwt/qwt_legend.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_legend.cpp	(revision 9383)
@@ -50,5 +50,5 @@
 };
 
-void QwtLegendMap::insert( const QVariant &itemInfo, 
+void QwtLegendMap::insert( const QVariant &itemInfo,
     const QList<QWidget *> &widgets )
 {
@@ -142,5 +142,5 @@
 {
 public:
-    LegendView( QWidget *parent ):
+    explicit LegendView( QWidget *parent ):
         QScrollArea( parent )
     {
@@ -296,4 +296,6 @@
     if ( tl )
         tl->setMaxColumns( numColums );
+
+    updateGeometry();
 }
 
@@ -342,5 +344,5 @@
 
 /*!
-  The contents widget is the only child of the viewport of 
+  The contents widget is the only child of the viewport of
   the internal QScrollArea and the parent widget of all legend items.
 
@@ -371,5 +373,5 @@
 
 /*!
-  The contents widget is the only child of the viewport of 
+  The contents widget is the only child of the viewport of
   the internal QScrollArea and the parent widget of all legend items.
 
@@ -386,16 +388,16 @@
 
   \param itemInfo Info for an item
-  \param data List of legend entry attributes for the item
+  \param legendData List of legend entry attributes for the item
  */
-void QwtLegend::updateLegend( const QVariant &itemInfo, 
-    const QList<QwtLegendData> &data )
+void QwtLegend::updateLegend( const QVariant &itemInfo,
+    const QList<QwtLegendData> &legendData )
 {
     QList<QWidget *> widgetList = legendWidgets( itemInfo );
 
-    if ( widgetList.size() != data.size() )
+    if ( widgetList.size() != legendData.size() )
     {
         QLayout *contentsLayout = d_data->view->contentsWidget->layout();
 
-        while ( widgetList.size() > data.size() )
+        while ( widgetList.size() > legendData.size() )
         {
             QWidget *w = widgetList.takeLast();
@@ -410,7 +412,11 @@
         }
 
-        for ( int i = widgetList.size(); i < data.size(); i++ )
-        {
-            QWidget *widget = createWidget( data[i] );
+#if QT_VERSION >= 0x040700
+        widgetList.reserve( legendData.size() );
+#endif
+
+        for ( int i = widgetList.size(); i < legendData.size(); i++ )
+        {
+            QWidget *widget = createWidget( legendData[i] );
 
             if ( contentsLayout )
@@ -441,7 +447,7 @@
         updateTabOrder();
     }
-    
-    for ( int i = 0; i < data.size(); i++ )
-        updateWidget( widgetList[i], data[i] );
+
+    for ( int i = 0; i < legendData.size(); i++ )
+        updateWidget( widgetList[i], legendData[i] );
 }
 
@@ -451,19 +457,19 @@
   The default implementation returns a QwtLegendLabel.
 
-  \param data Attributes of the legend entry
+  \param legendData Attributes of the legend entry
   \return Widget representing data on the legend
-  
+
   \note updateWidget() will called soon after createWidget()
         with the same attributes.
  */
-QWidget *QwtLegend::createWidget( const QwtLegendData &data ) const
-{
-    Q_UNUSED( data );
+QWidget *QwtLegend::createWidget( const QwtLegendData &legendData ) const
+{
+    Q_UNUSED( legendData );
 
     QwtLegendLabel *label = new QwtLegendLabel();
     label->setItemMode( defaultItemMode() );
 
-    connect( label, SIGNAL( clicked() ), SLOT( itemClicked() ) );
-    connect( label, SIGNAL( checked( bool ) ), SLOT( itemChecked( bool ) ) );
+    connect( label, SIGNAL(clicked()), SLOT(itemClicked()) );
+    connect( label, SIGNAL(checked(bool)), SLOT(itemChecked(bool)) );
 
     return label;
@@ -471,19 +477,19 @@
 
 /*!
-  \brief Update the widget 
+  \brief Update the widget
 
   \param widget Usually a QwtLegendLabel
-  \param data Attributes to be displayed
+  \param legendData Attributes to be displayed
 
   \sa createWidget()
   \note When widget is no QwtLegendLabel updateWidget() does nothing.
  */
-void QwtLegend::updateWidget( QWidget *widget, const QwtLegendData &data )
+void QwtLegend::updateWidget( QWidget *widget, const QwtLegendData &legendData )
 {
     QwtLegendLabel *label = qobject_cast<QwtLegendLabel *>( widget );
     if ( label )
     {
-        label->setData( data );
-        if ( !data.value( QwtLegendData::ModeRole ).isValid() )
+        label->setData( legendData );
+        if ( !legendData.value( QwtLegendData::ModeRole ).isValid() )
         {
             // use the default mode, when there is no specific
@@ -541,5 +547,5 @@
 
 /*!
-  Handle QEvent::ChildRemoved andQEvent::LayoutRequest events 
+  Handle QEvent::ChildRemoved andQEvent::LayoutRequest events
   for the contentsWidget().
 
@@ -557,9 +563,15 @@
             case QEvent::ChildRemoved:
             {
-                const QChildEvent *ce = 
+                const QChildEvent *ce =
                     static_cast<const QChildEvent *>(event);
+
                 if ( ce->child()->isWidgetType() )
                 {
-                    QWidget *w = static_cast< QWidget * >( ce->child() );
+                    /*
+                        We are called from the ~QObject and ce->child() is
+                        no widget anymore. But all we need is the address
+                        to remove it from the map.
+                     */
+                    QWidget *w = reinterpret_cast< QWidget * >( ce->child() );
                     d_data->itemMap.removeWidget( w );
                 }
@@ -585,5 +597,5 @@
                     QApplication::postEvent( parentWidget(),
                         new QEvent( QEvent::LayoutRequest ) );
-                }                
+                }
                 break;
             }
@@ -645,9 +657,9 @@
   \param painter Painter
   \param rect Bounding rectangle
-  \param fillBackground When true, fill rect with the widget background 
+  \param fillBackground When true, fill rect with the widget background
 
   \sa renderLegend() is used by QwtPlotRenderer - not by QwtLegend itself
 */
-void QwtLegend::renderLegend( QPainter *painter, 
+void QwtLegend::renderLegend( QPainter *painter,
     const QRectF &rect, bool fillBackground ) const
 {
@@ -664,5 +676,5 @@
     }
 
-    const QwtDynGridLayout *legendLayout = 
+    const QwtDynGridLayout *legendLayout =
         qobject_cast<QwtDynGridLayout *>( contentsWidget()->layout() );
     if ( legendLayout == NULL )
@@ -672,5 +684,5 @@
     getContentsMargins( &left, &top, &right, &bottom );
 
-    QRect layoutRect; 
+    QRect layoutRect;
     layoutRect.setLeft( qCeil( rect.left() ) + left );
     layoutRect.setTop( qCeil( rect.top() ) + top );
@@ -679,5 +691,5 @@
 
     uint numCols = legendLayout->columnsForWidth( layoutRect.width() );
-    QList<QRect> itemRects =
+    const QList<QRect> itemRects =
         legendLayout->layoutItems( layoutRect, numCols );
 
@@ -707,10 +719,10 @@
   \param widget Widget representing a legend entry
   \param rect Bounding rectangle
-  \param fillBackground When true, fill rect with the widget background 
+  \param fillBackground When true, fill rect with the widget background
 
   \note When widget is not derived from QwtLegendLabel renderItem
         does nothing beside the background
 */
-void QwtLegend::renderItem( QPainter *painter, 
+void QwtLegend::renderItem( QPainter *painter,
     const QWidget *widget, const QRectF &rect, bool fillBackground ) const
 {
@@ -733,5 +745,5 @@
 
         const QRectF iconRect( rect.x() + label->margin(),
-            rect.center().y() - 0.5 * sz.height(), 
+            rect.center().y() - 0.5 * sz.height(),
             sz.width(), sz.height() );
 
@@ -743,6 +755,10 @@
         titleRect.setX( iconRect.right() + 2 * label->spacing() );
 
-        painter->setFont( label->font() );
+        QFont labelFont = label->font();
+        labelFont.resolve( QFont::AllPropertiesResolved );
+
+        painter->setFont( labelFont );
         painter->setPen( label->palette().color( QPalette::Text ) );
+
         const_cast< QwtLegendLabel *>( label )->drawText( painter, titleRect );
     }
@@ -795,5 +811,5 @@
     Return the extent, that is needed for the scrollbars
 
-    \param orientation Orientation ( 
+    \param orientation Orientation
     \return The width of the vertical scrollbar for Qt::Horizontal and v.v.
  */
Index: trunk/BNC/qwt/qwt_legend.h
===================================================================
--- trunk/BNC/qwt/qwt_legend.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_legend.h	(revision 9383)
@@ -52,13 +52,13 @@
 
     virtual QSize sizeHint() const;
-    virtual int heightForWidth( int w ) const;
+    virtual int heightForWidth( int width ) const;
 
     QScrollBar *horizontalScrollBar() const;
     QScrollBar *verticalScrollBar() const;
 
-    virtual void renderLegend( QPainter *, 
+    virtual void renderLegend( QPainter *,
         const QRectF &, bool fillBackground ) const;
 
-    virtual void renderItem( QPainter *, 
+    virtual void renderItem( QPainter *,
         const QWidget *, const QRectF &, bool fillBackground ) const;
 
@@ -106,5 +106,5 @@
 protected:
     virtual QWidget *createWidget( const QwtLegendData & ) const;
-    virtual void updateWidget( QWidget *widget, const QwtLegendData &data );
+    virtual void updateWidget( QWidget *widget, const QwtLegendData & );
 
 private:
@@ -115,3 +115,3 @@
 };
 
-#endif 
+#endif
Index: trunk/BNC/qwt/qwt_null_paintdevice.cpp
===================================================================
--- trunk/BNC/qwt/qwt_null_paintdevice.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_null_paintdevice.cpp	(revision 9383)
@@ -10,4 +10,5 @@
 #include "qwt_null_paintdevice.h"
 #include <qpaintengine.h>
+#include <qpainterpath.h>
 #include <qpixmap.h>
 
@@ -51,13 +52,13 @@
     virtual void drawPolygon(const QPoint *, int , PolygonDrawMode );
 
-    virtual void drawPixmap(const QRectF &, 
+    virtual void drawPixmap(const QRectF &,
         const QPixmap &, const QRectF &);
 
     virtual void drawTextItem(const QPointF &, const QTextItem &);
 
-    virtual void drawTiledPixmap(const QRectF &, 
+    virtual void drawTiledPixmap(const QRectF &,
         const QPixmap &, const QPointF &s);
 
-    virtual void drawImage(const QRectF &, 
+    virtual void drawImage(const QRectF &,
         const QImage &, const QRectF &, Qt::ImageConversionFlags );
 
@@ -65,5 +66,5 @@
     QwtNullPaintDevice *nullDevice();
 };
-    
+
 QwtNullPaintDevice::PaintEngine::PaintEngine():
     QPaintEngine( QPaintEngine::AllFeatures )
@@ -283,5 +284,5 @@
 }
 
-void QwtNullPaintDevice::PaintEngine::drawPixmap( 
+void QwtNullPaintDevice::PaintEngine::drawPixmap(
     const QRectF &rect, const QPixmap &pm, const QRectF &subRect )
 {
@@ -310,5 +311,5 @@
 
 void QwtNullPaintDevice::PaintEngine::drawTiledPixmap(
-    const QRectF &rect, const QPixmap &pixmap, 
+    const QRectF &rect, const QPixmap &pixmap,
     const QPointF &subRect)
 {
@@ -321,5 +322,5 @@
         QPaintEngine::drawTiledPixmap( rect, pixmap, subRect );
         return;
-    }   
+    }
 
     device->drawTiledPixmap( rect, pixmap, subRect );
@@ -327,5 +328,5 @@
 
 void QwtNullPaintDevice::PaintEngine::drawImage(
-    const QRectF &rect, const QImage &image, 
+    const QRectF &rect, const QImage &image,
     const QRectF &subRect, Qt::ImageConversionFlags flags)
 {
@@ -338,11 +339,11 @@
 
 void QwtNullPaintDevice::PaintEngine::updateState(
-    const QPaintEngineState &state)
-{
-    QwtNullPaintDevice *device = nullDevice();
-    if ( device == NULL )
-        return;
-
-    device->updateState( state );
+    const QPaintEngineState &engineState)
+{
+    QwtNullPaintDevice *device = nullDevice();
+    if ( device == NULL )
+        return;
+
+    device->updateState( engineState );
 }
 
@@ -380,5 +381,5 @@
 }
 
-/*! 
+/*!
     \return Render mode
     \sa setMode()
@@ -394,5 +395,5 @@
     if ( d_engine == NULL )
     {
-        QwtNullPaintDevice *that = 
+        QwtNullPaintDevice *that =
             const_cast< QwtNullPaintDevice * >( this );
 
@@ -403,5 +404,5 @@
 }
 
-/*! 
+/*!
     See QPaintDevice::metric()
 
@@ -415,5 +416,5 @@
     int value;
 
-    switch ( deviceMetric ) 
+    switch ( deviceMetric )
     {
         case PdmWidth:
@@ -530,5 +531,5 @@
 //! See QPaintEngine::drawPolygon()
 void QwtNullPaintDevice::drawPolygon(
-    const QPointF *points, int pointCount, 
+    const QPointF *points, int pointCount,
     QPaintEngine::PolygonDrawMode mode)
 {
@@ -540,5 +541,5 @@
 //! See QPaintEngine::drawPolygon()
 void QwtNullPaintDevice::drawPolygon(
-    const QPoint *points, int pointCount, 
+    const QPoint *points, int pointCount,
     QPaintEngine::PolygonDrawMode mode)
 {
@@ -549,5 +550,5 @@
 
 //! See QPaintEngine::drawPixmap()
-void QwtNullPaintDevice::drawPixmap( const QRectF &rect, 
+void QwtNullPaintDevice::drawPixmap( const QRectF &rect,
     const QPixmap &pm, const QRectF &subRect )
 {
@@ -567,5 +568,5 @@
 //! See QPaintEngine::drawTiledPixmap()
 void QwtNullPaintDevice::drawTiledPixmap(
-    const QRectF &rect, const QPixmap &pixmap, 
+    const QRectF &rect, const QPixmap &pixmap,
     const QPointF &subRect)
 {
@@ -577,5 +578,5 @@
 //! See QPaintEngine::drawImage()
 void QwtNullPaintDevice::drawImage(
-    const QRectF &rect, const QImage &image, 
+    const QRectF &rect, const QImage &image,
     const QRectF &subRect, Qt::ImageConversionFlags flags)
 {
@@ -587,5 +588,5 @@
 
 //! See QPaintEngine::updateState()
-void QwtNullPaintDevice::updateState( 
+void QwtNullPaintDevice::updateState(
     const QPaintEngineState &state )
 {
Index: trunk/BNC/qwt/qwt_null_paintdevice.h
===================================================================
--- trunk/BNC/qwt/qwt_null_paintdevice.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_null_paintdevice.h	(revision 9383)
@@ -18,9 +18,9 @@
   \brief A null paint device doing nothing
 
-  Sometimes important layout/rendering geometries are not 
-  available or changeable from the public Qt class interface. 
+  Sometimes important layout/rendering geometries are not
+  available or changeable from the public Qt class interface.
   ( f.e hidden in the style implementation ).
 
-  QwtNullPaintDevice can be used to manipulate or filter out 
+  QwtNullPaintDevice can be used to manipulate or filter out
   this information by analyzing the stream of paint primitives.
 
@@ -43,5 +43,5 @@
            the corresponding draw methods
          */
-        NormalMode, 
+        NormalMode,
 
         /*!
@@ -77,5 +77,5 @@
     virtual QPaintEngine *paintEngine() const;
 
-    virtual int metric( PaintDeviceMetric metric ) const;
+    virtual int metric( PaintDeviceMetric ) const;
 
     virtual void drawRects(const QRect *, int );
@@ -105,10 +105,10 @@
 
     virtual void drawTiledPixmap(const QRectF &,
-        const QPixmap &, const QPointF &s);
+        const QPixmap &, const QPointF & );
 
     virtual void drawImage(const QRectF &,
         const QImage &, const QRectF &, Qt::ImageConversionFlags );
 
-    virtual void updateState( const QPaintEngineState &state );
+    virtual void updateState( const QPaintEngineState & );
 
 protected:
Index: trunk/BNC/qwt/qwt_painter.cpp
===================================================================
--- trunk/BNC/qwt/qwt_painter.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_painter.cpp	(revision 9383)
@@ -20,4 +20,5 @@
 #include <qpalette.h>
 #include <qpaintdevice.h>
+#include <qpainterpath.h>
 #include <qpixmap.h>
 #include <qstyle.h>
@@ -33,5 +34,5 @@
 #endif
 
-#if QT_VERSION < 0x050000 
+#if QT_VERSION < 0x050000
 
 #ifdef Q_WS_X11
@@ -44,5 +45,5 @@
 bool QwtPainter::d_roundingAlignment = true;
 
-static inline bool qwtIsClippingNeeded( 
+static inline bool qwtIsClippingNeeded(
     const QPainter *painter, QRectF &clipRect )
 {
@@ -142,4 +143,10 @@
 bool QwtPainter::isX11GraphicsSystem()
 {
+    /*
+        The X11 paint engine has been removed with Qt 5.0, but
+        reintroduced with Qt 5.10. It can be enabled with
+        "export QT_XCB_NATIVE_PAINTING=1".
+     */
+
     static int onX11 = -1;
     if ( onX11 < 0 )
@@ -181,5 +188,5 @@
         }
 
-        const QTransform tr = painter->transform();
+        const QTransform &tr = painter->transform();
         if ( tr.isRotating() || tr.isScaling() )
         {
@@ -196,8 +203,8 @@
   to a paint engine that floors to integer values. For other paint engines
   ( PDF, SVG ) this flag has no effect.
-  QwtPainter stores this flag only, the rounding itself is done in 
+  QwtPainter stores this flag only, the rounding itself is done in
   the painting code ( f.e the plot items ).
 
-  The default setting is true. 
+  The default setting is true.
 
   \sa roundingAlignment(), isAligning()
@@ -214,4 +221,8 @@
   much faster when they are split in smaller chunks: f.e all supported Qt versions
   >= Qt 5.0 when drawing an antialiased polyline with a pen width >=2.
+
+  Also the raster paint engine has a nasty bug in many versions ( Qt 4.8 - ... )
+  for short lines ( https://codereview.qt-project.org/#/c/99456 ), that is worked
+  around in this mode.
 
   The default setting is true.
@@ -397,5 +408,5 @@
             unscaledRect = transform.inverted().mapRect(rect);
         }
-    }  
+    }
 
     txt->setDefaultFont( painter->font() );
@@ -452,5 +463,5 @@
     QPolygonF cpa = polygon;
     if ( deviceClipping )
-        cpa = QwtClipper::clipPolygonF( clipRect, polygon );
+        cpa = QwtClipper::clipPolygonF( clipRect, polygon, true );
 
     painter->drawPolygon( cpa );
@@ -501,5 +512,5 @@
     QPolygon cpa = polygon;
     if ( deviceClipping )
-        cpa = QwtClipper::clipPolygon( clipRect, polygon );
+        cpa = QwtClipper::clipPolygon( clipRect, polygon, true );
 
     painter->drawPolygon( cpa );
@@ -537,5 +548,7 @@
     }
     else
+    {
         qwtDrawPolyline<QPoint>( painter, points, pointCount, d_polylineSplitting );
+    }
 }
 
@@ -565,5 +578,5 @@
         const int maxY = qFloor( clipRect.bottom() );
 
-        if ( pos.x() < minX || pos.x() > maxX 
+        if ( pos.x() < minX || pos.x() > maxX
             || pos.y() < minY || pos.y() > maxY )
         {
@@ -576,5 +589,5 @@
 
 //! Wrapper for QPainter::drawPoints()
-void QwtPainter::drawPoints( QPainter *painter, 
+void QwtPainter::drawPoints( QPainter *painter,
     const QPoint *points, int pointCount )
 {
@@ -609,5 +622,5 @@
 
 //! Wrapper for QPainter::drawPoints()
-void QwtPainter::drawPoints( QPainter *painter, 
+void QwtPainter::drawPoints( QPainter *painter,
     const QPointF *points, int pointCount )
 {
@@ -697,5 +710,5 @@
 
 /*!
-  Draw a round frame 
+  Draw a round frame
 
   \param painter Painter
@@ -708,5 +721,5 @@
 */
 void QwtPainter::drawRoundFrame( QPainter *painter,
-    const QRectF &rect, const QPalette &palette, 
+    const QRectF &rect, const QPalette &palette,
     int lineWidth, int frameStyle )
 {
@@ -787,5 +800,5 @@
     {
         const QRectF outerRect = rect.adjusted( 0.0, 0.0, -1.0, -1.0 );
-        const QRectF innerRect = outerRect.adjusted( 
+        const QRectF innerRect = outerRect.adjusted(
             frameWidth, frameWidth, -frameWidth, -frameWidth );
 
@@ -806,10 +819,10 @@
         {
             const QRectF outerRect = rect.adjusted( 0.0, 0.0, -1.0, -1.0 );
-            const QRectF midRect1 = outerRect.adjusted( 
+            const QRectF midRect1 = outerRect.adjusted(
                 frameWidth, frameWidth, -frameWidth, -frameWidth );
-            const QRectF midRect2 = midRect1.adjusted( 
+            const QRectF midRect2 = midRect1.adjusted(
                 midLineWidth, midLineWidth, -midLineWidth, -midLineWidth );
 
-            const QRectF innerRect = midRect2.adjusted( 
+            const QRectF innerRect = midRect2.adjusted(
                 frameWidth, frameWidth, -frameWidth, -frameWidth );
 
@@ -887,6 +900,6 @@
         {
             const QRectF outerRect = rect.adjusted( 0.0, 0.0, -1.0, -1.0 );
-            const QRectF innerRect = outerRect.adjusted( 
-                frameWidth - 1.0, frameWidth - 1.0, 
+            const QRectF innerRect = outerRect.adjusted(
+                frameWidth - 1.0, frameWidth - 1.0,
                 -( frameWidth - 1.0 ), -( frameWidth - 1.0 ) );
 
@@ -942,6 +955,6 @@
 */
 
-void QwtPainter::drawRoundedFrame( QPainter *painter, 
-    const QRectF &rect, double xRadius, double yRadius, 
+void QwtPainter::drawRoundedFrame( QPainter *painter,
+    const QRectF &rect, double xRadius, double yRadius,
     const QPalette &palette, int lineWidth, int frameStyle )
 {
@@ -951,8 +964,8 @@
 
     double lw2 = lineWidth * 0.5;
-    QRectF r = rect.adjusted( lw2, lw2, -lw2, -lw2 );
+    QRectF innerRect = rect.adjusted( lw2, lw2, -lw2, -lw2 );
 
     QPainterPath path;
-    path.addRoundedRect( r, xRadius, yRadius );
+    path.addRoundedRect( innerRect, xRadius, yRadius );
 
     enum Style
@@ -973,25 +986,25 @@
         // move + 4 * ( cubicTo + lineTo )
         QPainterPath pathList[8];
-        
+
         for ( int i = 0; i < 4; i++ )
         {
             const int j = i * 4 + 1;
-            
+
             pathList[ 2 * i ].moveTo(
                 path.elementAt(j - 1).x, path.elementAt( j - 1 ).y
-            );  
-            
+            );
+
             pathList[ 2 * i ].cubicTo(
                 path.elementAt(j + 0).x, path.elementAt(j + 0).y,
                 path.elementAt(j + 1).x, path.elementAt(j + 1).y,
                 path.elementAt(j + 2).x, path.elementAt(j + 2).y );
-                
+
             pathList[ 2 * i + 1 ].moveTo(
                 path.elementAt(j + 2).x, path.elementAt(j + 2).y
-            );  
+            );
             pathList[ 2 * i + 1 ].lineTo(
                 path.elementAt(j + 3).x, path.elementAt(j + 3).y
-            );  
-        }   
+            );
+        }
 
         QColor c1( palette.color( QPalette::Dark ) );
@@ -1003,5 +1016,5 @@
         for ( int i = 0; i < 4; i++ )
         {
-            QRectF r = pathList[2 * i].controlPointRect();
+            const QRectF r = pathList[2 * i].controlPointRect();
 
             QPen arcPen;
@@ -1147,8 +1160,8 @@
 }
 
-static inline void qwtFillRect( const QWidget *widget, QPainter *painter, 
+static inline void qwtFillRect( const QWidget *widget, QPainter *painter,
     const QRect &rect, const QBrush &brush)
 {
-    if ( brush.style() == Qt::TexturePattern ) 
+    if ( brush.style() == Qt::TexturePattern )
     {
         painter->save();
@@ -1158,5 +1171,5 @@
 
         painter->restore();
-    } 
+    }
     else if ( brush.gradient() )
     {
@@ -1164,10 +1177,10 @@
 
         painter->setClipRect( rect );
-        painter->fillRect(0, 0, widget->width(), 
+        painter->fillRect(0, 0, widget->width(),
             widget->height(), brush);
 
         painter->restore();
-    } 
-    else 
+    }
+    else
     {
         painter->fillRect(rect, brush);
@@ -1179,14 +1192,14 @@
 
   In Qt >= 5.0 QPixmap::fill() is a nop, in Qt 4.x it is buggy
-  for backgrounds with gradients. Thus fillPixmap() offers 
+  for backgrounds with gradients. Thus fillPixmap() offers
   an alternative implementation.
 
   \param widget Widget
   \param pixmap Pixmap to be filled
-  \param offset Offset 
+  \param offset Offset
 
   \sa QPixmap::fill()
  */
-void QwtPainter::fillPixmap( const QWidget *widget, 
+void QwtPainter::fillPixmap( const QWidget *widget,
     QPixmap &pixmap, const QPoint &offset )
 {
@@ -1196,8 +1209,8 @@
     painter.translate( -offset );
 
-    const QBrush autoFillBrush = 
+    const QBrush autoFillBrush =
         widget->palette().brush( widget->backgroundRole() );
 
-    if ( !( widget->autoFillBackground() && autoFillBrush.isOpaque() ) ) 
+    if ( !( widget->autoFillBackground() && autoFillBrush.isOpaque() ) )
     {
         const QBrush bg = widget->palette().brush( QPalette::Window );
@@ -1208,5 +1221,5 @@
         qwtFillRect( widget, &painter, rect, autoFillBrush);
 
-    if ( widget->testAttribute(Qt::WA_StyledBackground) ) 
+    if ( widget->testAttribute(Qt::WA_StyledBackground) )
     {
         painter.setClipRegion( rect );
@@ -1214,5 +1227,5 @@
         QStyleOption opt;
         opt.initFrom( widget );
-        widget->style()->drawPrimitive( QStyle::PE_Widget, 
+        widget->style()->drawPrimitive( QStyle::PE_Widget,
             &opt, &painter, widget );
     }
@@ -1285,5 +1298,5 @@
 #endif
 
-#if QT_VERSION < 0x050000 
+#if QT_VERSION < 0x050000
 #ifdef Q_WS_X11
     if ( widget && isX11GraphicsSystem() )
Index: trunk/BNC/qwt/qwt_painter.h
===================================================================
--- trunk/BNC/qwt/qwt_painter.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_painter.h	(revision 9383)
@@ -51,5 +51,5 @@
     static void drawText( QPainter *, double x, double y, double w, double h,
         int flags, const QString & );
-    static void drawText( QPainter *, const QRectF &, 
+    static void drawText( QPainter *, const QRectF &,
         int flags, const QString & );
 
@@ -64,5 +64,5 @@
 
     static void drawEllipse( QPainter *, const QRectF & );
-    static void drawPie( QPainter *, const QRectF & r, int a, int alen );
+    static void drawPie( QPainter *, const QRectF &, int a, int alen );
 
     static void drawLine( QPainter *, double x1, double y1, double x2, double y2 );
@@ -94,5 +94,5 @@
         const QRectF &, const QPalette &, int lineWidth, int frameStyle );
 
-    static void drawRoundedFrame( QPainter *, 
+    static void drawRoundedFrame( QPainter *,
         const QRectF &, double xRadius, double yRadius,
         const QPalette &, int lineWidth, int frameStyle );
@@ -100,5 +100,5 @@
     static void drawFrame( QPainter *, const QRectF &rect,
         const QPalette &palette, QPalette::ColorRole foregroundRole,
-        int lineWidth, int midLineWidth, int frameStyle ); 
+        int frameWidth, int midLineWidth, int frameStyle );
 
     static void drawFocusRect( QPainter *, const QWidget * );
@@ -112,5 +112,5 @@
     static bool isX11GraphicsSystem();
 
-    static void fillPixmap( const QWidget *, 
+    static void fillPixmap( const QWidget *,
         QPixmap &, const QPoint &offset = QPoint() );
 
Index: trunk/BNC/qwt/qwt_painter_command.h
===================================================================
--- trunk/BNC/qwt/qwt_painter_command.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_painter_command.h	(revision 9383)
@@ -16,4 +16,5 @@
 #include <qimage.h>
 #include <qpolygon.h>
+#include <qpainterpath.h>
 
 class QPainterPath;
@@ -27,5 +28,5 @@
   \sa QwtGraphic::commands()
  */
-  
+
 class QWT_EXPORT QwtPainterCommand
 {
@@ -50,5 +51,5 @@
     };
 
-    //! Attributes how to paint a QPixmap 
+    //! Attributes how to paint a QPixmap
     struct PixmapData
     {
@@ -58,5 +59,5 @@
     };
 
-    //! Attributes how to paint a QImage 
+    //! Attributes how to paint a QImage
     struct ImageData
     {
@@ -151,5 +152,5 @@
 
 //! \return Attributes how to paint a QPixmap
-inline const QwtPainterCommand::PixmapData* 
+inline const QwtPainterCommand::PixmapData *
 QwtPainterCommand::pixmapData() const
 {
@@ -158,5 +159,5 @@
 
 //! \return Attributes how to paint a QImage
-inline const QwtPainterCommand::ImageData * 
+inline const QwtPainterCommand::ImageData *
 QwtPainterCommand::imageData() const
 {
@@ -165,5 +166,5 @@
 
 //! \return Attributes of a state change
-inline const QwtPainterCommand::StateData * 
+inline const QwtPainterCommand::StateData *
 QwtPainterCommand::stateData() const
 {
Index: trunk/BNC/qwt/qwt_panner.cpp
===================================================================
--- trunk/BNC/qwt/qwt_panner.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_panner.cpp	(revision 9383)
@@ -129,5 +129,5 @@
    \param modifiers Keyboard modifiers
 */
-void QwtPanner::setAbortKey( int key, 
+void QwtPanner::setAbortKey( int key,
     Qt::KeyboardModifiers modifiers )
 {
@@ -137,5 +137,5 @@
 
 //! Get the abort key and modifiers
-void QwtPanner::getAbortKey( int &key, 
+void QwtPanner::getAbortKey( int &key,
     Qt::KeyboardModifiers &modifiers ) const
 {
@@ -248,15 +248,19 @@
    fill the empty spaces by the background of the parent widget.
 
-   \param pe Paint event
-*/
-void QwtPanner::paintEvent( QPaintEvent *pe )
+   \param event Paint event
+*/
+void QwtPanner::paintEvent( QPaintEvent *event )
 {
     int dx = d_data->pos.x() - d_data->initialPos.x();
     int dy = d_data->pos.y() - d_data->initialPos.y();
 
-    QRect r( 0, 0, d_data->pixmap.width(), d_data->pixmap.height() );
-    r.moveCenter( QPoint( r.center().x() + dx, r.center().y() + dy ) );
-
-    QPixmap pm( size() );
+    QRectF r;
+    r.setSize( d_data->pixmap.size() );
+#if QT_VERSION >= 0x050000
+    r.setSize( r.size() / d_data->pixmap.devicePixelRatio() );
+#endif
+    r.moveCenter( QPointF( r.center().x() + dx, r.center().y() + dy ) );
+
+    QPixmap pm = QwtPainter::backingStore( this, size() );
     QwtPainter::fillPixmap( parentWidget(), pm );
 
@@ -267,9 +271,9 @@
         QPixmap masked = d_data->pixmap;
         masked.setMask( d_data->contentsMask );
-        painter.drawPixmap( r, masked );
+        painter.drawPixmap( r.toRect(), masked );
     }
     else
     {
-        painter.drawPixmap( r, d_data->pixmap );
+        painter.drawPixmap( r.toRect(), d_data->pixmap );
     }
 
@@ -280,5 +284,5 @@
 
     painter.begin( this );
-    painter.setClipRegion( pe->region() );
+    painter.setClipRegion( event->region() );
     painter.drawPixmap( 0, 0, pm );
 }
